﻿using System;
using System.Collections.Generic;
using System.Text;

namespace DateTimeStudy
{
    /// <summary>
    /// DateTime扩展类
    /// </summary>
    public static class DateTimeExtensions
    {
        /// <summary>
        /// 以毫秒为单位的UTC时间戳
        /// </summary>
        public static long ToUtcTimestamp(this DateTime sourceDate)
        {
            var utcTimeStart = new DateTime(1970, 1, 1, 0, 0, 0, DateTimeKind.Utc);
            return (sourceDate - utcTimeStart).Ticks;
        }

        /// <summary>
        /// 毫秒单位UTC时间戳转当地时间
        /// </summary>
        public static DateTime ToLocalTime(this long utcTimestamp)
        {
            DateTime utcTimeStart = new DateTime(1970, 1, 1, 0, 0, 0, DateTimeKind.Utc);

            var timeSpan = new TimeSpan(utcTimestamp);

            return utcTimeStart.Add(timeSpan).ToLocalTime();
        }
    }
}
